SystemOrganization addCategory: #'Pier-GoogleMaps'!

!PRViewRenderer methodsFor: '*pier-googlemaps' stamp: 'jmck 4/8/2009 21:33'!
visitGoogleMap: aStructure
	html visitCase: aStructure.
	! !

PRDefaultView subclass: #PMGoogleMapView
	instanceVariableNames: 'map report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-GoogleMaps'!

!PMGoogleMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 19:30'!
buildReport
	^MAReport rows: self map markers description: (PMGoogleStaticMapMarker description)! !

!PMGoogleMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 13:30'!
map
	^map ifNil: [ map := self context structure ]! !

!PMGoogleMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 19:29'!
report
	^report ifNil: [ report := self buildReport ]! !

PMGoogleMapView subclass: #PMGoogleStaticMapView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-GoogleMaps'!

!PMGoogleStaticMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 22:20'!
markers
	^self map allMapMarkersIn: self context! !

!PMGoogleStaticMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 23:16'!
moveMapTo: aMarker
	self map longitude: aMarker longitude.
	self map latitude: aMarker latitude.! !

!PMGoogleStaticMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 22:37'!
renderContentOn: html
	super renderContentOn: html.
	self renderToolsOn: html.
	html googleStaticMap
		latitude: self map latitude;
		longitude: self map longitude;
		width: self map width;
		height: self map height;
		type: self map type;
		zoom: self map zoom;
		key: self map key;
		markers: self urlParameterMarkers .
	self renderMarkersOn: html.! !

!PMGoogleStaticMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 23:28'!
renderMarkersOn: html
	html div class: 'markers'; with: [
		html heading level: 2; with: 'Markers'.
		html table: [
			self markers do: [ :mark | 
				html tableRow: [
					html tableData: [ html anchor callback: [ self moveMapTo: mark ]; with: mark character ]. 
					html tableData: mark text.
					]
				]
			]
		]! !

!PMGoogleStaticMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 23:36'!
renderToolsOn: html
	html table: [
		html tableRow: [
			html tableData: [ html anchor callback: [ self map zoomOut ]; with: '<< Zoom Out' ].
			html tableData: [ html anchor callback: [ self map zoomIn ]; with: 'Zoom In >>' ].
			]
		]
! !

!PMGoogleStaticMapView methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 22:58'!
urlParameterMarkers
	^self markers collect: [ :mark | 
		GMStaticMapMarker new
			latitude: mark latitude;
			longitude: mark longitude;
			character: mark character;
			color: mark color;
			yourself]! !

PRCase subclass: #PMGoogleStaticMap
	instanceVariableNames: 'latitude longitude zoom type markers key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-GoogleMaps'!

!PMGoogleStaticMap class methodsFor: 'testing' stamp: 'jmck 4/8/2009 20:06'!
canBeParentOf: aClass
	^aClass includesBehavior: PMGoogleStaticMapMarker! !

!PMGoogleStaticMap class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 17:13'!
descriptionAPIKey
	^MAStringDescription new
		label: 'Google Maps API Key';
		accessor: (MAChainAccessor on: #key accessor: (MASelectorAccessor selector: #apiKey));
		beEditable;
		priority: 1;
		yourself! !

!PMGoogleStaticMap class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 18:59'!
descriptionHeight
	^MANumberDescription new
		label: 'Height';
		accessor: #height;
		default: 400;
		beInteger;
		beEditable;
		priority: 60;
		yourself! !

!PMGoogleStaticMap class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:21'!
descriptionLatitude
	^MANumberDescription new
		label: 'Latitude';
		accessor: #latitude;
		addCondition: [ :l | l >= -90 and: [ l <= 90 ] ];
		beEditable;
		priority: 10;
		yourself! !

!PMGoogleStaticMap class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:21'!
descriptionLongitude
	^MANumberDescription new
		label: 'Longitude';
		accessor: #longitude;
		addCondition: [ :l | l >= -180 and: [ l <= 180 ] ];
		beEditable;
		priority: 20;
		yourself! !

!PMGoogleStaticMap class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:22'!
descriptionType
	^MASingleOptionDescription new
		label: 'Map Type';
		accessor: #type;
		options: #('roadmap' 'mobile' 'satellite' 'terrain' 'hybrid' 'mapmaker' 'mapmaker-hybrid');
		beEditable;
		priority: 30;
		yourself! !

!PMGoogleStaticMap class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 18:59'!
descriptionWidth
	^MANumberDescription new
		label: 'Width';
		accessor: #width;
		default: 600;
		beInteger;
		beEditable;
		priority: 50;
		yourself! !

!PMGoogleStaticMap class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:22'!
descriptionZoom
	^MANumberDescription new
		label: 'Zoom';
		accessor: #zoom;
		addCondition: [ :z | z >= 0 and: [ z <= 19 ] ];
		beEditable;
		beInteger;
		priority: 40;
		yourself! !

!PMGoogleStaticMap class methodsFor: 'testing' stamp: 'jmck 4/8/2009 01:40'!
isAbstract
	^false! !

!PMGoogleStaticMap methodsFor: 'accessing-dynamic' stamp: 'jmck 4/8/2009 18:49'!
allMapMarkersIn: aContext
	^(aContext enumeratorFor: self) all select: [ :each | each isMarker ]! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 18:59'!
height
	"Answer the value of height"

	^ height! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 18:59'!
height: anObject
	"Set the value of height"

	height := anObject! !

!PMGoogleStaticMap methodsFor: 'initialization' stamp: 'jmck 4/8/2009 16:56'!
initialize
	super initialize.
	key := GMApiKey current! !

!PMGoogleStaticMap methodsFor: 'testing' stamp: 'jmck 4/8/2009 18:47'!
isMarker
	^false! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
key
	"Answer the value of key"

	^ key! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
key: anObject
	"Set the value of key"

	key := anObject! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
latitude
	"Answer the value of latitude"

	^ latitude! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
latitude: anObject
	"Set the value of latitude"

	latitude := anObject! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
longitude
	"Answer the value of longitude"

	^ longitude! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
longitude: anObject
	"Set the value of longitude"

	longitude := anObject! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 19:08'!
markers
	"Answer the value of markers"

	^ markers! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
markers: anObject
	"Set the value of markers"

	markers := anObject! !

!PMGoogleStaticMap methodsFor: 'actions' stamp: 'jmck 4/8/2009 18:28'!
panLeft! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
type
	"Answer the value of type"

	^ type! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
type: anObject
	"Set the value of type"

	type := anObject! !

!PMGoogleStaticMap methodsFor: 'rendering' stamp: 'jmck 4/8/2009 13:17'!
viewComponentClass
	^PMGoogleStaticMapView! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 18:59'!
width
	"Answer the value of width"

	^ width! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 18:59'!
width: anObject
	"Set the value of width"

	width := anObject! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
zoom
	"Answer the value of zoom"

	^ zoom! !

!PMGoogleStaticMap methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:30'!
zoom: anObject
	"Set the value of zoom"

	zoom := anObject! !

!PMGoogleStaticMap methodsFor: 'actions' stamp: 'jmck 4/8/2009 18:27'!
zoomIn
	zoom < 19 ifTrue: [ zoom := zoom + 1 ]! !

!PMGoogleStaticMap methodsFor: 'actions' stamp: 'jmck 4/8/2009 18:27'!
zoomOut
	zoom > 0 ifTrue: [ zoom := zoom - 1 ]! !

PRCase subclass: #PMGoogleStaticMapMarker
	instanceVariableNames: 'latitude longitude character color text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-GoogleMaps'!

!PMGoogleStaticMapMarker class methodsFor: 'testing' stamp: 'jmck 4/8/2009 20:06'!
canBeChildOf: aClass
	^aClass includesBehavior: PMGoogleStaticMap! !

!PMGoogleStaticMapMarker class methodsFor: 'testing' stamp: 'jmck 4/8/2009 20:05'!
canBeParentOf: aClass
	^false! !

!PMGoogleStaticMapMarker class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:25'!
descriptionCharacter
	^MAStringDescription new
		label: 'Character';
		accessor: #character;
		addCondition: [ :c | c size < 2 and: [ c asCharacter isAlphaNumeric  ] ];
		beEditable;
		priority: 40;
		yourself! !

!PMGoogleStaticMapMarker class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 23:03'!
descriptionColor
	^MASingleOptionDescription new
		label: 'Color';
		accessor: #color;
		options: #('black' 'brown' 'green' 'purple' 'yellow' 'blue' 'gray' 'orange' 'red' 'white'); 
		beEditable;
		priority: 30;
		yourself! !

!PMGoogleStaticMapMarker class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:23'!
descriptionLatitude
	^MANumberDescription new
		label: 'Latitude';
		accessor: #latitude;
		addCondition: [ :l | l >= -90 and: [ l <= 90 ] ];
		beEditable;
		priority: 10;
		yourself! !

!PMGoogleStaticMapMarker class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 01:23'!
descriptionLongitude
	^MANumberDescription new
		label: 'Longitude';
		accessor: #longitude;
		addCondition: [ :l | l >= -180 and: [ l <= 180 ] ];
		beEditable;
		priority: 20;
		yourself! !

!PMGoogleStaticMapMarker class methodsFor: 'accessing' stamp: 'jmck 4/8/2009 23:00'!
descriptionText
	^MAStringDescription new
		label: 'Text';
		accessor: #text;
		beEditable;
		priority: 90;
		yourself! !

!PMGoogleStaticMapMarker class methodsFor: 'testing' stamp: 'jmck 4/8/2009 01:40'!
isAbstract
	^false! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
character
	"Answer the value of character"

	^ character! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
character: anObject
	"Set the value of character"

	character := anObject! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
color
	"Answer the value of color"

	^ color! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
color: anObject
	"Set the value of color"

	color := anObject! !

!PMGoogleStaticMapMarker methodsFor: 'as yet unclassified' stamp: 'jmck 4/8/2009 18:48'!
isMarker
	^true! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
latitude
	"Answer the value of latitude"

	^ latitude! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
latitude: anObject
	"Set the value of latitude"

	latitude := anObject! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
longitude
	"Answer the value of longitude"

	^ longitude! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
longitude: anObject
	"Set the value of longitude"

	longitude := anObject! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
text
	"Answer the value of text"

	^ text! !

!PMGoogleStaticMapMarker methodsFor: 'accessing' stamp: 'jmck 4/8/2009 20:19'!
text: anObject
	"Set the value of text"

	text := anObject! !
